/**********************************************************************
 * $Id: example.java,v 1.6 2005/01/04 12:30:57 igbrotru Exp $
 *
 * Name:     example.java
 * Project:  JGDAL. Interface java to gdal (Frank Warmerdam).
 * Purpose:  Example code to test java interface of gdal. 
 * Author:   Nacho Brodin, brodin_ign@gva.es
 *
 **********************************************************************/
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/



/**
 * Sections that correspond with GDAL Api Tutorial (publicated in
 * http://www.remotesensing.org:16080/gdal/gdal_tutorial.html) have
 * been marked.
 */

//Opening the file ----------------------------

import es.gva.cit.jgdal.*;

import java.io.*;

public class example{
	public static void main(String[] args){
 
	  
	  Gdal migdal=new Gdal();
	  
	  try{
	    if(args.length>0)
	    	migdal.open(args[0],Gdal.GA_ReadOnly);
	    else {
	    	System.out.println("You must introduce the file name"); 
	    	System.exit(1);
	    }
	  }catch(Exception ge){
			ge.printStackTrace();
			//...........
	  }

//End Opening the file ----------------------------
	  
	  
	  GdalRasterBand mirasterband=null;
	  GdalRasterBand mioverview=null;
  
	  FileOutputStream s=null;
	  DataOutputStream midataOS=null;
	  BufferedOutputStream miBS=null;
	  String st;
	  int nxsize=0;
	  int nysize=0;
	  int rastercount=0;
	  String rasterband;
	  int xoverview=0;
	  int yoverview=0;
	  GeoTransform gt;
	  int noverviews=0;
	    
//Getting dataset Information ----------------------------	  
	  
	  try{
	  	rastercount=migdal.getRasterCount();
	    nxsize = migdal.getRasterXSize();
	    nysize = migdal.getRasterYSize();
	    System.out.println("N BANDAS="+rastercount+" SIZEX="+nxsize+" SIZEY="+nysize);
	    System.out.println(migdal.getProjectionRef());	
	  }catch(GdalException ge){
	  						ge.printStackTrace();
	  						//...........
	  					   }
	  
	  
	  
	  try{
	  	gt=migdal.getGeoTransform();
	  	System.out.println("Origin = ("+gt.adfgeotransform[0]+","+gt.adfgeotransform[3]+")");
	  	System.out.println("Pixel Size = ("+gt.adfgeotransform[1]+","+gt.adfgeotransform[5]+")");
	  }catch(GdalException e){
	  		System.out.println("I can't obtain the array geoTransform for this image");
			e.printStackTrace();
			//...........
	  }
	  
//End Getting dataset Information ----------------------------	  
	  
	  try{
	       File mifichero=new File("exit.raw");
	       s = new FileOutputStream(mifichero);
	  }catch(Exception e){}
	  

	  for(int iBand=0;iBand<rastercount;iBand++){
	  	
	  	System.out.println("-------");
	  	
	  	//Informacion de banda

	  
//Fetching a Raster Band ----------------------------	  
//Several binding are missing yet	  	
	  	
	  	int tipo=0;
	  	try{
	  		mirasterband=migdal.getRasterBand(iBand+1);
	  		System.out.println("SIZE BANDA=("+mirasterband.getRasterBandXSize()+","+mirasterband.getRasterBandYSize()+")");
	  		System.out.println("SIZE BLOQUE BANDA=("+mirasterband.getBlockXSize()+","+mirasterband.getBlockYSize()+")");
	  		noverviews=mirasterband.getOverviewCount();
	  		System.out.println("N OVERVIEWS="+noverviews);
	  		tipo = mirasterband.getRasterDataType();
	  		System.out.println("TIPO DE DATOS BANDA="+tipo);
	  	}catch(GdalException e){
	  		e.printStackTrace();
	  		System.exit(1);
	  	}
	  	
//Fetching a Raster Band ----------------------------
	  	
	  	
	  	System.out.println("BANDA->"+iBand);
	  	
	  	//Informacin de overview
	  	
	  	try{
	  			  		
	  		if(noverviews>0){
	  			
	  			//Muestra el tamao de cada overview y selecccionamos el 0
	  			
	  			for(int t=0;t<noverviews;t++){
	  				mioverview=mirasterband.getOverview(t);
	  				System.out.println("SIZE OVERVIEW=("+mioverview.getRasterBandXSize()+","+mioverview.getRasterBandYSize()+")");
	  			}
	  			mioverview=mirasterband.getOverview(0);
	  			xoverview=mioverview.getRasterBandXSize();
	  			yoverview=mioverview.getRasterBandYSize();
	  		}else{
	  			System.out.println("This band haven't overviews");
		  		xoverview=nxsize;
				yoverview=nysize;
				mioverview=mirasterband;	
	  			
	  		}
	  		
	  	}catch(GdalException e){
	  		e.printStackTrace();
	  		System.exit(1);
	  	}
	  	
	  	
	  	
	  	
	  	
	  	
	  	
		//byte[] buf=null;
		GdalBuffer buf=null;
		
	  	for(int i=0; i<yoverview; i++){

//Reading Raster Data ----------------------------	  
	  		
		  	try{
		  		buf = mioverview.readRaster(0, i, xoverview, 1, xoverview, 1, tipo);
		  	}catch(GdalException e){
		  		System.out.println("Error in BSBReadLine");
		  		System.exit(1);
		  	}

//End Reading Raster Data ----------------------------		  	
		  	
	  		/*try{
	  			if(tipo==Gdal.GDT_Byte)s.write(buf.buffByte);
	  		}catch(IOException e){
	  			System.out.println("Error writing a line in the file\n");	
	  			System.exit(1);
	  		}*/
		
	  	}
	  	
	}
	  
	 
	  
	  try{	  	
	  	System.out.println("-METADATOS-");
	    String[] metadatos = migdal.getMetadata();
	    for(int i=0;i<metadatos.length;i++)System.out.println(metadatos[i]);
	    	    
	    migdal.close();
	  }catch(GdalException e){
	  							e.printStackTrace();
	  						 }
	  
	  
	}  
}