 /**********************************************************************
 * $Id: ogrtools_interfaz.cpp,v 1.3 2006/01/09 12:50:13 nacho Exp $
 *
 * Name:     OGRSpatialReference_interfaz.c
 * Project:  JGDAL. Interface java to gdal (Frank Warmerdam).
 * Purpose:  dataset's Basic Funcions.
 * Author:   Nacho Brodin, brodin_ign@gva.es
 *
 **********************************************************************/
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/


#include <jni.h>
#include "es_gva_cit_jogr_OGRTools.h"
#include "es_gva_cit_jogr_JNIBase.h"
#include "gdal.h"
#include "cpl_string.h"
#include "ogr_api.h"
#include "ogrsf_frmts.h"


/******************************************************************************/
//						 OGRCreateCoordinateTransformation
/******************************************************************************/

JNIEXPORT jlong JNICALL Java_es_gva_cit_jogr_OGRTools_OGRCreateCoordinateTransformationNat
  (JNIEnv *env, jclass clase, jlong ptro_source, jlong ptro_target){
  	
  	OGRSpatialReference 			*source = (OGRSpatialReference *) 0 ;
  	OGRSpatialReference 			*target = (OGRSpatialReference *) 0 ;
  	OGRCoordinateTransformation 	*poCT = NULL;
  	long 							ptr_ct = -1;
  	
  	source = *(OGRSpatialReference **)&ptro_source;
  	target = *(OGRSpatialReference **)&ptro_target;
  	poCT = OGRCreateCoordinateTransformation( source, target );
  	ptr_ct = (long)&(*poCT);
  	return (jlong)ptr_ct;
  }
  
  